using System.IO.Compression;

void WriteString(Stream stream, string s, int size)
{
    var bytes = Encoding.ASCII.GetBytes(s);
    var i = 0;
    foreach (var b in bytes)
    {
        if (i >= size) break;
        stream.WriteByte(b);
        ++i;
    }
    while (i < size)
    {
        stream.WriteByte(0);
        ++i;
    }
}

void WriteWordL(Stream stream, int value)
{
    stream.WriteByte((byte)value);
    stream.WriteByte((byte)(value >> 8));
}

void WriteWordH(Stream stream, int value)
{
    stream.WriteByte((byte)(value >> 8));
    stream.WriteByte((byte)value);
}

void WriteDWordL(Stream stream, int value)
{
    WriteWordL(stream, value);
    WriteWordL(stream, value >> 16);
}


var name = Args[0];
var address = Convert.ToInt32(Args[1], 16);
var bin = new byte[0x8000];

var size = 0;
using (var stream = new FileStream(name + ".bin", FileMode.Open, FileAccess.Read))
{
    size = stream.Read(bin);
}

using (var stream = new GZipStream(new FileStream(name + ".uef", FileMode.Create, FileAccess.Write), CompressionLevel.Optimal))
{
    WriteString(stream, "UEF File!", 10);
    WriteWordL(stream, 0x000a);

    WriteWordL(stream, 0x110);
    WriteDWordL(stream, 2);
    WriteWordL(stream, 5000);

    WriteWordL(stream, 0x100);
    WriteDWordL(stream, 4 + size);
    WriteWordH(stream, address + size);
    WriteWordH(stream, address);
    stream.Write(bin, 0, size);
}